
// FFFTP2View.cpp : CFFFTP2View NX̎
//

#include "stdafx.h"
// SHARED_HANDLERS ́Avr[AkŁAьtB^[ nh[Ă ATL vWFNgŒ`łA
// ̃vWFNgƂ̃hLg R[h̋L\ɂ܂B
#ifndef SHARED_HANDLERS
#include "FFFTP2.h"
#endif

#include "FFFTP2Doc.h"
#include "FFFTP2View.h"

extern "C" {
#include "common.h"
}

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CFFFTP2View

IMPLEMENT_DYNCREATE(CFFFTP2View, CFormView)

BEGIN_MESSAGE_MAP(CFFFTP2View, CFormView)
	ON_WM_CONTEXTMENU()
	ON_WM_RBUTTONUP()
	ON_WM_SIZE()
	ON_NOTIFY(LVN_ITEMACTIVATE, IDC_LIST_REMOTE, &CFFFTP2View::OnItemactivateListRemote)
	ON_NOTIFY(NM_DBLCLK, IDC_LIST_REMOTE, &CFFFTP2View::OnDblclkListRemote)
	ON_BN_CLICKED(IDC_BUTTON_REMOTE_UP, &CFFFTP2View::OnClickedButtonRemoteUp)
	ON_NOTIFY(LVN_ITEMACTIVATE, IDC_LIST_LOCAL, &CFFFTP2View::OnItemactivateListLocal)
	ON_NOTIFY(NM_DBLCLK, IDC_LIST_LOCAL, &CFFFTP2View::OnDblclkListLocal)
	ON_BN_CLICKED(IDC_BUTTON_LOCAL_UP, &CFFFTP2View::OnClickedButtonLocalUp)
END_MESSAGE_MAP()

// CFFFTP2View RXgNV/fXgNV

CFFFTP2View::CFFFTP2View()
	: CFormView(IDD_FFFTP2_FORM)
{
	// TODO: \zR[hɒǉ܂B
}

CFFFTP2View::~CFFFTP2View()
{
}

void CFFFTP2View::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_BUTTON_LOCAL_UP, m_btnLocalUp);
	DDX_Control(pDX, IDC_BUTTON_LOCAL_OPEN, m_btnLocalOpen);
	DDX_Control(pDX, IDC_COMBOBOX_LOCAL, m_cbLocal);
	DDX_Control(pDX, IDC_LIST_LOCAL, m_lvLocal);
	DDX_Control(pDX, IDC_BUTTON_REMOTE_UP, m_btnRemoteUp);
	DDX_Control(pDX, IDC_BUTTON_REMOTE_OPEN, m_btnRemoteOpen);
	DDX_Control(pDX, IDC_COMBOBOX_REMOTE, m_cbRemote);
	DDX_Control(pDX, IDC_LIST_REMOTE, m_lvRemote);
}

BOOL CFFFTP2View::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: ̈ʒu CREATESTRUCT cs C Window NX܂̓X^C
	//  CĂB

	return CFormView::PreCreateWindow(cs);
}


extern "C" {
	void SetWndListLocal(HWND h);
	void SetWndListRemote(HWND h);
	void SetListImg(HIMAGELIST h);
}

void CFFFTP2View::OnInitialUpdate()
{
	CFormView::OnInitialUpdate();
	ResizeParentToFit();

	SetWndListRemote(m_lvRemote.GetSafeHwnd());
	SetWndListLocal(m_lvLocal.GetSafeHwnd());

	m_imageList.Create(dirattr_bmp, 16, 5, RGB(255, 0, 0));
	m_lvLocal.SetImageList(&m_imageList, LVSIL_SMALL);
	m_lvRemote.SetImageList(&m_imageList, LVSIL_SMALL);
	SetListImg(m_imageList.GetSafeHandle());
	static CBitmap bmpup; bmpup.LoadBitmapA(IDB_BITMAP_UP);
	static CBitmap bmpopen; bmpopen.LoadBitmapA(IDB_BITMAP_OPEN);

	m_btnLocalOpen.SetBitmap(bmpopen);
	m_btnRemoteOpen.SetBitmap(bmpopen);
	m_btnLocalUp.SetBitmap(bmpup);
	m_btnRemoteUp.SetBitmap(bmpup);

	{
		auto lv = &m_lvLocal;
		lv->ModifyStyle(0, LVS_SHOWSELALWAYS);
		lv->SetExtendedStyle(LVS_EX_FULLROWSELECT);

		lv->InsertColumn(0, CString("O"), 0, 100);
		lv->InsertColumn(1, CString("t"), 0, 100);
		lv->InsertColumn(2, CString("TCY"), 0, 50);
		lv->InsertColumn(3, CString(""), 0, 50);
	}

	{
		auto lv = &m_lvRemote;
		lv->ModifyStyle(0, LVS_SHOWSELALWAYS);
		lv->SetExtendedStyle(LVS_EX_FULLROWSELECT);

		lv->InsertColumn(0, CString("O"), 0, 100);
		lv->InsertColumn(1, CString("t"), 0, 100);
		lv->InsertColumn(2, CString("TCY"), 0, 50);
		lv->InsertColumn(3, CString(""), 0, 50);
		lv->InsertColumn(4, CString(""), 0, 50);
		lv->InsertColumn(5, CString("L"), 0, 50);
	}
	this->GetParent()->SetWindowTextA("hostname");
	GetLocalDirForWnd();
}

void CFFFTP2View::OnRButtonUp(UINT /* nFlags */, CPoint point)
{
	ClientToScreen(&point);
	OnContextMenu(this, point);
}

void CFFFTP2View::OnContextMenu(CWnd* /* pWnd */, CPoint point)
{
#ifndef SHARED_HANDLERS
	theApp.GetContextMenuManager()->ShowPopupMenu(IDR_POPUP_EDIT, point.x, point.y, this, TRUE);
#endif
}


// CFFFTP2View ff

#ifdef _DEBUG
void CFFFTP2View::AssertValid() const
{
	CFormView::AssertValid();
}

void CFFFTP2View::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CFFFTP2Doc* CFFFTP2View::GetDocument() const // fobOȊÕo[W̓CCłB
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CFFFTP2Doc)));
	return (CFFFTP2Doc*)m_pDocument;
}
#endif //_DEBUG


// CFFFTP2View bZ[W nh[
// CMFCApplication2View bZ[W nh[

void CFFFTP2View::OnSize(UINT nType, int cx, int cy)
{
	CFormView::OnSize(nType, cx, cy);

	CRect rc(0, 0, cx, cy);
	// ʒu킹
	int MARGIN_W = 4;
	int MARGIN_H = 4;
	int BTN_W = 20;
	int BTN_H = 20;
	CRect rcLocalUp(MARGIN_W, MARGIN_H, MARGIN_W + BTN_W, MARGIN_H + BTN_H);
	CRect rcLocalOpen(rcLocalUp.right + MARGIN_W, MARGIN_H, rcLocalUp.right + MARGIN_W + BTN_W, MARGIN_H + BTN_H);
	CRect rccbLocal(rcLocalOpen.right + MARGIN_W, MARGIN_H, rc.Width() / 2 - MARGIN_W, MARGIN_H + BTN_H);
	CRect rclvLocal(rcLocalUp.left, rcLocalUp.bottom + MARGIN_H, rc.Width() / 2 - MARGIN_W, rc.Height() - MARGIN_H);
	CRect rcRemoteUp(rc.Width() / 2 + MARGIN_W, MARGIN_H, rc.Width() / 2 + MARGIN_W + BTN_W, MARGIN_H + BTN_H);
	CRect rcRemoteOpen(rcRemoteUp.right + MARGIN_W, MARGIN_H, rcRemoteUp.right + MARGIN_W + BTN_W, MARGIN_H + BTN_H);
	CRect rccbRemote(rcRemoteOpen.right + MARGIN_W, MARGIN_H, rc.Width() - MARGIN_W, MARGIN_H + BTN_H);
	CRect rclvRemote(rcRemoteUp.left, rcRemoteUp.bottom + MARGIN_H, rc.Width() - MARGIN_W, rc.Height() - MARGIN_H);

	UINT uFlags = SWP_NOACTIVATE | SWP_NOOWNERZORDER | SWP_NOZORDER;
	HDWP wp = BeginDeferWindowPos(8);
	DeferWindowPos(wp, m_btnLocalUp.GetSafeHwnd(), NULL, rcLocalUp.left, rcLocalUp.top, rcLocalUp.Width(), rcLocalUp.Height(), uFlags);
	DeferWindowPos(wp, m_btnLocalOpen.GetSafeHwnd(), NULL, rcLocalOpen.left, rcLocalOpen.top, rcLocalOpen.Width(), rcLocalOpen.Height(), uFlags);
	DeferWindowPos(wp, m_cbLocal.GetSafeHwnd(), NULL, rccbLocal.left, rccbLocal.top, rccbLocal.Width(), rccbLocal.Height(), uFlags);
	DeferWindowPos(wp, m_lvLocal.GetSafeHwnd(), NULL, rclvLocal.left, rclvLocal.top, rclvLocal.Width(), rclvLocal.Height(), uFlags);
	DeferWindowPos(wp, m_btnRemoteUp.GetSafeHwnd(), NULL, rcRemoteUp.left, rcRemoteUp.top, rcRemoteUp.Width(), rcRemoteUp.Height(), uFlags);
	DeferWindowPos(wp, m_btnRemoteOpen.GetSafeHwnd(), NULL, rcRemoteOpen.left, rcRemoteOpen.top, rcRemoteOpen.Width(), rcRemoteOpen.Height(), uFlags);
	DeferWindowPos(wp, m_cbRemote.GetSafeHwnd(), NULL, rccbRemote.left, rccbRemote.top, rccbRemote.Width(), rccbRemote.Height(), uFlags);
	DeferWindowPos(wp, m_lvRemote.GetSafeHwnd(), NULL, rclvRemote.left, rclvRemote.top, rclvRemote.Width(), rclvRemote.Height(), uFlags);
	EndDeferWindowPos(wp);
}

/// [gXg̃ANeBu
void CFFFTP2View::OnItemactivateListRemote(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMITEMACTIVATE pNMIA = reinterpret_cast<LPNMITEMACTIVATE>(pNMHDR);
	// TODO: ɃRg[ʒmnh[ R[hǉ܂B
	*pResult = 0;
}

/// [gXg̃_uNbN
void CFFFTP2View::OnDblclkListRemote(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMITEMACTIVATE pNMItemActivate = reinterpret_cast<LPNMITEMACTIVATE>(pNMHDR);
	DoubleClickProc(WIN_REMOTE, YES, -1);
	*pResult = 0;
}

/// [gXg̐etH_
void CFFFTP2View::OnClickedButtonRemoteUp()
{
	// SuppressRefresh = 1;
	SetCurrentDirAsDirHist();
	ChangeDir(WIN_REMOTE, "..");
	// SuppressRefresh = 0;
}

/// [JXg̃ANeBu
void CFFFTP2View::OnItemactivateListLocal(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMITEMACTIVATE pNMIA = reinterpret_cast<LPNMITEMACTIVATE>(pNMHDR);
	*pResult = 0;
}

/// [JXg̃_uNbN
void CFFFTP2View::OnDblclkListLocal(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMITEMACTIVATE pNMItemActivate = reinterpret_cast<LPNMITEMACTIVATE>(pNMHDR);
	DoubleClickProc(WIN_LOCAL, YES, -1);
	*pResult = 0;
}

/// [JXg̐etH_
void CFFFTP2View::OnClickedButtonLocalUp()
{
	SetCurrentDirAsDirHist();
	ChangeDir(WIN_LOCAL, "..");
}
